﻿Imports System.Runtime.InteropServices
Imports System.ComponentModel

Public Enum LoadOption
	Add
	Initialize
	Ignore
End Enum
Public Class CloudTag
	Inherits Label
#Region " Private Setup stuff "
	<Flags()> _
	Private Enum SetWindowPosFlags As UInteger
		SynchronousWindowPosition = &H4000
		DeferErase = &H2000
		DrawFrame = &H20
		FrameChanged = &H20
		HideWindow = &H80
		DoNotActivate = &H10
		DoNotCopyBits = &H100
		IgnoreMove = &H2
		DoNotChangeOwnerZOrder = &H200
		DoNotRedraw = &H8
		DoNotReposition = &H200
		DoNotSendChangingEvent = &H400
		IgnoreResize = &H1
		IgnoreZOrder = &H4
		ShowWindow = &H40
	End Enum
	<Flags()> _
	Private Enum WindowStylesEx As UInteger
		''' <summary>
		''' Specifies that a window created with this style accepts drag-drop files.
		''' </summary>
		WS_EX_ACCEPTFILES = &H10
		''' <summary>
		''' Forces a top-level window onto the taskbar when the window is visible.
		''' </summary>
		WS_EX_APPWINDOW = &H40000
		''' <summary>
		''' Specifies that a window has a border with a sunken edge.
		''' </summary>
		WS_EX_CLIENTEDGE = &H200
		''' <summary>
		''' Windows XP: Paints all descendants of a window in bottom-to-top painting order using double-buffering. For more information, see Remarks. This cannot be used if the window has a class style of either CS_OWNDC or CS_CLASSDC. 
		''' </summary>
		WS_EX_COMPOSITED = &H2000000
		''' <summary>
		''' Includes a question mark in the title bar of the window. When the user clicks the question mark, the cursor changes to a question mark with a pointer. If the user then clicks a child window, the child receives a WM_HELP message. The child window should pass the message to the parent window procedure, which should call the WinHelp function using the HELP_WM_HELP command. The Help application displays a pop-up window that typically contains help for the child window.
		''' WS_EX_CONTEXTHELP cannot be used with the WS_MAXIMIZEBOX or WS_MINIMIZEBOX styles.
		''' </summary>
		WS_EX_CONTEXTHELP = &H400
		''' <summary>
		''' The window itself contains child windows that should take part in dialog box navigation. If this style is specified, the dialog manager recurses into children of this window when performing navigation operations such as handling the TAB key, an arrow key, or a keyboard mnemonic.
		''' </summary>
		WS_EX_CONTROLPARENT = &H10000
		''' <summary>
		''' Creates a window that has a double border; the window can, optionally, be created with a title bar by specifying the WS_CAPTION style in the dwStyle parameter.
		''' </summary>
		WS_EX_DLGMODALFRAME = &H1
		''' <summary>
		''' Windows 2000/XP: Creates a layered window. Note that this cannot be used for child windows. Also, this cannot be used if the window has a class style of either CS_OWNDC or CS_CLASSDC. 
		''' </summary>
		WS_EX_LAYERED = &H80000
		''' <summary>
		''' Arabic and Hebrew versions of Windows 98/Me, Windows 2000/XP: Creates a window whose horizontal origin is on the right edge. Increasing horizontal values advance to the left. 
		''' </summary>
		WS_EX_LAYOUTRTL = &H400000
		''' <summary>
		''' Creates a window that has generic left-aligned properties. This is the default.
		''' </summary>
		WS_EX_LEFT = &H0
		''' <summary>
		''' If the shell language is Hebrew, Arabic, or another language that supports reading order alignment, the vertical scroll bar (if present) is to the left of the client area. For other languages, the style is ignored.
		''' </summary>
		WS_EX_LEFTSCROLLBAR = &H4000
		''' <summary>
		''' The window text is displayed using left-to-right reading-order properties. This is the default.
		''' </summary>
		WS_EX_LTRREADING = &H0
		''' <summary>
		''' Creates a multiple-document interface (MDI) child window.
		''' </summary>
		WS_EX_MDICHILD = &H40
		''' <summary>
		''' Windows 2000/XP: A top-level window created with this style does not become the foreground window when the user clicks it. The system does not bring this window to the foreground when the user minimizes or closes the foreground window. 
		''' To activate the window, use the SetActiveWindow or SetForegroundWindow function.
		''' The window does not appear on the taskbar by default. To force the window to appear on the taskbar, use the WS_EX_APPWINDOW style.
		''' </summary>
		WS_EX_NOACTIVATE = &H8000000
		''' <summary>
		''' Windows 2000/XP: A window created with this style does not pass its window layout to its child windows.
		''' </summary>
		WS_EX_NOINHERITLAYOUT = &H100000
		''' <summary>
		''' Specifies that a child window created with this style does not send the WM_PARENTNOTIFY message to its parent window when it is created or destroyed.
		''' </summary>
		WS_EX_NOPARENTNOTIFY = &H4
		''' <summary>
		''' Combines the WS_EX_CLIENTEDGE and WS_EX_WINDOWEDGE styles.
		''' </summary>
		WS_EX_OVERLAPPEDWINDOW = WS_EX_WINDOWEDGE Or WS_EX_CLIENTEDGE
		''' <summary>
		''' Combines the WS_EX_WINDOWEDGE, WS_EX_TOOLWINDOW, and WS_EX_TOPMOST styles.
		''' </summary>
		WS_EX_PALETTEWINDOW = WS_EX_WINDOWEDGE Or WS_EX_TOOLWINDOW Or WS_EX_TOPMOST
		''' <summary>
		''' The window has generic "right-aligned" properties. This depends on the window class. This style has an effect only if the shell language is Hebrew, Arabic, or another language that supports reading-order alignment; otherwise, the style is ignored.
		''' Using the WS_EX_RIGHT style for static or edit controls has the same effect as using the SS_RIGHT or ES_RIGHT style, respectively. Using this style with button controls has the same effect as using BS_RIGHT and BS_RIGHTBUTTON styles.
		''' </summary>
		WS_EX_RIGHT = &H1000
		''' <summary>
		''' Vertical scroll bar (if present) is to the right of the client area. This is the default.
		''' </summary>
		WS_EX_RIGHTSCROLLBAR = &H0
		''' <summary>
		''' If the shell language is Hebrew, Arabic, or another language that supports reading-order alignment, the window text is displayed using right-to-left reading-order properties. For other languages, the style is ignored.
		''' </summary>
		WS_EX_RTLREADING = &H2000
		''' <summary>
		''' Creates a window with a three-dimensional border style intended to be used for items that do not accept user input.
		''' </summary>
		WS_EX_STATICEDGE = &H20000
		''' <summary>
		''' Creates a tool window; that is, a window intended to be used as a floating toolbar. A tool window has a title bar that is shorter than a normal title bar, and the window title is drawn using a smaller font. A tool window does not appear in the taskbar or in the dialog that appears when the user presses ALT+TAB. If a tool window has a system menu, its icon is not displayed on the title bar. However, you can display the system menu by right-clicking or by typing ALT+SPACE. 
		''' </summary>
		WS_EX_TOOLWINDOW = &H80
		''' <summary>
		''' Specifies that a window created with this style should be placed above all non-topmost windows and should stay above them, even when the window is deactivated. To add or remove this style, use the SetWindowPos function.
		''' </summary>
		WS_EX_TOPMOST = &H8
		''' <summary>
		''' Specifies that a window created with this style should not be painted until siblings beneath the window (that were created by the same thread) have been painted. The window appears transparent because the bits of underlying sibling windows have already been painted.
		''' To achieve transparency without these restrictions, use the SetWindowRgn function.
		''' </summary>
		WS_EX_TRANSPARENT = &H20
		''' <summary>
		''' Specifies that a window has a border with a raised edge.
		''' </summary>
		WS_EX_WINDOWEDGE = &H100
	End Enum

	''' <summary>
	''' Window Styles.
	''' The following styles can be specified wherever a window style is required. After the control has been created, these styles cannot be modified, except as noted.
	''' </summary>
	<Flags()> Private Enum WindowStyles As UInteger
		''' <summary>The window has a thin-line border.</summary>
		WS_BORDER = &H800000

		''' <summary>The window has a title bar (includes the WS_BORDER style).</summary>
		WS_CAPTION = &HC00000

		''' <summary>The window is a child window. A window with this style cannot have a menu bar. This style cannot be used with the WS_POPUP style.</summary>
		WS_CHILD = &H40000000

		''' <summary>Excludes the area occupied by child windows when drawing occurs within the parent window. This style is used when creating the parent window.</summary>
		WS_CLIPCHILDREN = &H2000000

		''' <summary>
		''' Clips child windows relative to each other; that is, when a particular child window receives a WM_PAINT message, the WS_CLIPSIBLINGS style clips all other overlapping child windows out of the region of the child window to be updated.
		''' If WS_CLIPSIBLINGS is not specified and child windows overlap, it is possible, when drawing within the client area of a child window, to draw within the client area of a neighboring child window.
		''' </summary>
		WS_CLIPSIBLINGS = &H4000000

		''' <summary>The window is initially disabled. A disabled window cannot receive input from the user. To change this after a window has been created, use the EnableWindow function.</summary>
		WS_DISABLED = &H8000000

		''' <summary>The window has a border of a style typically used with dialog boxes. A window with this style cannot have a title bar.</summary>
		WS_DLGFRAME = &H400000

		''' <summary>
		''' The window is the first control of a group of controls. The group consists of this first control and all controls defined after it, up to the next control with the WS_GROUP style.
		''' The first control in each group usually has the WS_TABSTOP style so that the user can move from group to group. The user can subsequently change the keyboard focus from one control in the group to the next control in the group by using the direction keys.
		''' You can turn this style on and off to change dialog box navigation. To change this style after a window has been created, use the SetWindowLong function.
		''' </summary>
		WS_GROUP = &H20000

		''' <summary>The window has a horizontal scroll bar.</summary>
		WS_HSCROLL = &H100000

		''' <summary>The window is initially maximized.</summary> 
		WS_MAXIMIZE = &H1000000

		''' <summary>The window has a maximize button. Cannot be combined with the WS_EX_CONTEXTHELP style. The WS_SYSMENU style must also be specified.</summary> 
		WS_MAXIMIZEBOX = &H10000

		''' <summary>The window is initially minimized.</summary>
		WS_MINIMIZE = &H20000000

		''' <summary>The window has a minimize button. Cannot be combined with the WS_EX_CONTEXTHELP style. The WS_SYSMENU style must also be specified.</summary>
		WS_MINIMIZEBOX = &H20000

		''' <summary>The window is an overlapped window. An overlapped window has a title bar and a border.</summary>
		WS_OVERLAPPED = &H0

		''' <summary>The window is an overlapped window.</summary>
		WS_OVERLAPPEDWINDOW = WS_OVERLAPPED Or WS_CAPTION Or WS_SYSMENU Or WS_SIZEFRAME Or WS_MINIMIZEBOX Or WS_MAXIMIZEBOX

		''' <summary>The window is a pop-up window. This style cannot be used with the WS_CHILD style.</summary>
		WS_POPUP = &H80000000UI

		''' <summary>The window is a pop-up window. The WS_CAPTION and WS_POPUPWINDOW styles must be combined to make the window menu visible.</summary>
		WS_POPUPWINDOW = WS_POPUP Or WS_BORDER Or WS_SYSMENU

		''' <summary>The window has a sizing border.</summary>
		WS_SIZEFRAME = &H40000

		''' <summary>The window has a window menu on its title bar. The WS_CAPTION style must also be specified.</summary>
		WS_SYSMENU = &H80000

		''' <summary>
		''' The window is a control that can receive the keyboard focus when the user presses the TAB key.
		''' Pressing the TAB key changes the keyboard focus to the next control with the WS_TABSTOP style.  
		''' You can turn this style on and off to change dialog box navigation. To change this style after a window has been created, use the SetWindowLong function.
		''' For user-created windows and modeless dialogs to work with tab stops, alter the message loop to call the IsDialogMessage function.
		''' </summary>
		WS_TABSTOP = &H10000

		''' <summary>The window is initially visible. This style can be turned on and off by using the ShowWindow or SetWindowPos function.</summary>
		WS_VISIBLE = &H10000000

		''' <summary>The window has a vertical scroll bar.</summary>
		WS_VSCROLL = &H200000
	End Enum
	Private Structure NMHDR
		Dim hwndFrom As IntPtr
		Dim idFrom As Integer
		Dim code As Integer
	End Structure
	<StructLayout(LayoutKind.Sequential)> _
	Private Structure WCCLICKED
		Public hdr As NMHDR
		Public pszKey As IntPtr
		Public cnt As Integer
	End Structure
	<StructLayout(LayoutKind.Sequential)> _
	Private Structure LLCLICKED
		Public hdr As NMHDR
		Public pszKey As IntPtr
	End Structure
	Private Const SWP_NOMOVE = &H2
	Private Const SWP_NOZORDER = &H4
	Private Const COLOR_3DFACE = 15
	Private Const WM_NOTIFY = &H4E
	Private Declare Function SetWindowPos Lib "user32.dll" (ByVal hWnd As IntPtr, ByVal hWndInsertAfter As IntPtr, ByVal x As Integer, ByVal y As Integer, ByVal cx As Integer, ByVal cy As Integer, ByVal uFlags As SetWindowPosFlags) As Boolean
	<DllImport("user32.dll")> _
	Private Shared Function GetSysColor(ByVal nIndex As Integer) As Integer
		' Use nIndex = 1 to get Desktop color
	End Function

	'WordCloud.bas
	Private Declare Ansi Function NewWordCloud Lib "control" (ByVal hParent As IntPtr, ByVal pLeft As Integer, ByVal pTop As Integer, ByVal pWidth As Integer, ByVal pHeight As Integer, ByVal Id As Integer) As UInt32
	Private Declare Ansi Sub WordCloud_PaintControl Lib "control" (ByVal hWnd As IntPtr, ByVal resumeOrSuspend As wcPaintControl)
	Private Declare Ansi Function WordCloud_GetPaintControl Lib "control" (ByVal hWnd As IntPtr) As wcPaintControl
	Private Declare Ansi Sub WordCloud_SetIgnoreCount Lib "control" (ByVal hWnd As IntPtr, ByVal ignoreUpTo As Integer)
	Private Declare Ansi Function WordCloud_GetIgnoreCount Lib "control" (ByVal hWnd As IntPtr) As Integer
	Private Declare Ansi Sub WordCloud_LoadFile Lib "control" (ByVal hWnd As IntPtr, ByVal filename As String)
	Private Declare Ansi Sub WordCloud_LoadText Lib "control" (ByVal hWnd As IntPtr, ByVal value As String)
	Private Declare Ansi Sub WordCloud_AddFile Lib "control" (ByVal hWnd As IntPtr, ByVal filename As String)
	Private Declare Ansi Sub WordCloud_AddText Lib "control" (ByVal hWnd As IntPtr, ByVal value As String)
	Private Declare Ansi Sub WordCloud_IgnoreFile Lib "control" (ByVal hWnd As IntPtr, ByVal filename As String)
	Private Declare Ansi Sub WordCloud_IgnoreText Lib "control" (ByVal hWnd As IntPtr, ByVal value As String)
	Private Declare Ansi Sub WordCloud_Sort Lib "control" (ByVal hWnd As IntPtr, ByVal sortType As wcSortType)
	Private Declare Ansi Function WordCloud_GetSort Lib "control" (ByVal hWnd As IntPtr) As wcSortType
	Private Declare Ansi Sub WordCloud_SetColor Lib "control" (ByVal hWnd As IntPtr, ByVal color1 As Integer, ByVal backColor As Integer, ByVal color2 As Integer)
	Private Declare Ansi Function WordCloud_GetColor1 Lib "control" (ByVal hWnd As IntPtr) As Integer
	Private Declare Ansi Function WordCloud_GetColor2 Lib "control" (ByVal hWnd As IntPtr) As Integer
	Private Declare Ansi Function WordCloud_GetBackColor Lib "control" (ByVal hWnd As IntPtr) As Integer
	Private Declare Ansi Sub WordCloud_SetFontname Lib "control.dll" (ByVal hWnd As IntPtr, ByVal fontname As String)
	Private Declare Ansi Function WordCloud_GetFontname Lib "control.dll" (ByVal hWnd As IntPtr) As IntPtr
	Private Const USER1 = &H400
	Private Const WCN_Clicked = 1	' Code

	Public Enum wcSortType
		Name = 1
		NameDescending = 2
		Frequency = 3
		FrequencyDescending = 4
		Length = 5
		LengthDescending = 6
	End Enum
	Public Enum wcPaintControl
		ResumePainting = 0
		SuspendPainting = 1
	End Enum

	' LinkLabel.bas
	Private Declare Ansi Function NewLinkLabel Lib "control" (ByVal hParent As Integer, ByVal pText As String, ByVal pLeft As Integer, ByVal pTop As Integer, ByVal pHeight As Integer, ByVal Id As Integer) As Integer

	Private Const LLM_GetForeColor = USER1 + 1	' Return is forecolor
	Private Const LLM_GetBackColor = USER1 + 2	' Return is backcolor
	Private Const LLM_SetColor = USER1 + 3	' wParam = foreColor, lParam = backColor

	Private Const LLN_Clicked = 2	' Code
#End Region

	Private hTag As IntPtr
	Public Event Clicked(ByVal sender As Object, ByVal key As String, ByVal cnt As Integer)

	Sub New()
		MyBase.New()
		Me.AutoSize = False
		Me.Text = ""
		hTag = NewWordCloud(Me.Handle, 0, 0, Me.ClientSize.Width, Me.ClientSize.Height, 101)
	End Sub
#Region " Public Routines "
	Sub LoadFile(ByVal filename As String, Optional loadOption As LoadOption = LoadOption.Initialize)
		Select Case loadOption
			Case WindowsApplication1.LoadOption.Add
				Call WordCloud_AddFile(hTag, filename)
			Case WindowsApplication1.LoadOption.Initialize
				Call WordCloud_LoadFile(hTag, filename)
			Case WindowsApplication1.LoadOption.Ignore
				Call WordCloud_IgnoreFile(hTag, filename)
		End Select
	End Sub
	Sub LoadText(ByVal value As String, Optional loadOption As LoadOption = LoadOption.Initialize)
		Select Case loadOption
			Case WindowsApplication1.LoadOption.Add
				Call WordCloud_AddText(hTag, value)
			Case WindowsApplication1.LoadOption.Initialize
				Call WordCloud_LoadText(hTag, value)
			Case WindowsApplication1.LoadOption.Ignore
				Call WordCloud_IgnoreText(hTag, value)
		End Select
	End Sub
	<DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden), Browsable(False)>
	Public Property PaintControl As wcPaintControl
		Get
			Return WordCloud_GetPaintControl(hTag)
		End Get
		Set(value As wcPaintControl)
			Call WordCloud_PaintControl(hTag, value)
		End Set
	End Property
	Public Property IgnoreCount As Integer
		Get
			Return WordCloud_GetIgnoreCount(hTag)
		End Get
		Set(value As Integer)
			Call WordCloud_SetIgnoreCount(hTag, value)
		End Set
	End Property
	Public Property Fontname As String
		Get
			Dim pname = WordCloud_GetFontname(hTag)
			Dim fname As String = Marshal.PtrToStringAnsi(pname)
			Return fname
		End Get
		Set(ByVal value As String)
			WordCloud_SetFontname(hTag, value)
		End Set
	End Property
	Public Property Color1 As Color
		Get
			Dim value As UInt32 = WordCloud_GetColor1(hTag)
			Dim r, g, b As Integer
			r = value And 255
			value >>= 8
			g = value And 255
			value >>= 8
			b = value And 255
			Return Color.FromArgb(r, b, g)
		End Get
		Set(value As Color)
			Dim clr As UInt32 = (CInt(value.B) << 16) + (CInt(value.G) << 8) + CInt(value.R)
			Call WordCloud_SetColor(hTag, clr, WordCloud_GetColor2(hTag), WordCloud_GetBackColor(hTag))
		End Set
	End Property
	<DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden), Browsable(False)>
	Public Shadows Property BackColor As Color
		Get
			Dim value As UInt32 = WordCloud_GetBackColor(hTag)
			Dim r, g, b As Integer
			r = value And 255
			value >>= 8
			g = value And 255
			value >>= 8
			b = value And 255
			Return Color.FromArgb(r, b, g)
		End Get
		Set(value As Color)
			Dim clr As UInt32 = (CInt(value.B) << 16) + (CInt(value.G) << 8) + CInt(value.R)
			Call WordCloud_SetColor(hTag, WordCloud_GetColor1(hTag), clr, WordCloud_GetColor2(hTag))
		End Set
	End Property
	Public Property Color2 As Color
		Get
			' .Net and windows colors are not the same?
			Dim value As UInt32 = WordCloud_GetColor2(hTag)
			Dim r, g, b As Integer
			r = value And 255
			value >>= 8
			g = value And 255
			value >>= 8
			b = value And 255
			Return Color.FromArgb(r, b, g)
		End Get
		Set(value As Color)
			Dim clr As UInt32 = (CInt(value.B) << 16) + (CInt(value.G) << 8) + CInt(value.R)
			Call WordCloud_SetColor(hTag, WordCloud_GetColor1(hTag), WordCloud_GetBackColor(hTag), clr)
		End Set
	End Property
	<DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden), Browsable(False)>
	Public Property Sort As wcSortType
		Get
			Return WordCloud_GetSort(hTag)
		End Get
		Set(value As wcSortType)
			Call WordCloud_Sort(hTag, value)
		End Set
	End Property
#End Region
#Region " Internal Routines "
	Private Sub CloudTag_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
		SetWindowPos(hTag, 0, 0, 0, Me.ClientSize.Width, Me.ClientSize.Height, SWP_NOMOVE Or SWP_NOZORDER)
	End Sub
	Protected Overrides Sub WndProc(ByRef m As System.Windows.Forms.Message)
		If m.Msg = WM_NOTIFY Then
			Dim hdr As NMHDR = CType(Marshal.PtrToStructure(m.LParam, GetType(NMHDR)), NMHDR)
			If hdr.hwndFrom = hTag Then
				Dim wc As WCCLICKED
				wc = CType(Marshal.PtrToStructure(m.LParam, GetType(WCCLICKED)), WCCLICKED)
				Dim key As String = Marshal.PtrToStringAnsi(wc.pszKey)
				Dim cnt As Integer = wc.cnt
				RaiseEvent Clicked(Me, key, cnt)
				m.Result = 0
				Exit Sub
			End If
		End If
		MyBase.WndProc(m)
	End Sub
#End Region
End Class