#If Not %Def(%INCLUDE)
#Compile SLL
#Dim All
#Register All
#EndIf

#Include Once "control.inc"
#Include Once "Win32Api.inc"

Type LinkLabelData
	foreColor As Long
	backColor As Long
	hover As Long
	font As Long
	hoverFont As Long
	bdown As Long
End Type

Function NewLinkLabel Alias "NewLinkLabel"(ByVal hParent As Long, ByRef pText As AsciiZ, ByVal pLeft As Long, ByVal pTop As Long, ByVal pHeight As Long, ByVal Id As Long) Common Export As Long
	Local hWnd As Long
	Local className As AsciiZ*20
	className = "lcLinkLabel"

	Call LinkLabelInit()
	hWnd = CreateWindowEx( 0, className, pText, %WS_Child Or %WS_Visible, pLeft, pTop, 10, pHeight, hParent, Id, GetModuleHandle( ByVal 0), ByVal 0 )

	Function = hWnd
End Function

Sub LinkLabelInit()
	Static className As AsciiZ*20
	Local wc As WNDCLASS

	className = "lcLinkLabel"

	If GetClassInfo(%NULL, className, wc) Then Exit Sub: ' Already registered


	' Register class for lcLinkLabel window
	wc.style = %CS_GLOBALCLASS
	wc.lpfnWndProc = CodePtr( LinkLabelCtlProc )
	wc.cbClsExtra = 0
	wc.cbWndExtra = 4
	wc.hInstance = GetModuleHandle( ByVal 0 )
	wc.hIcon = %NULL
	wc.hCursor = LoadCursor(%NULL, ByVal %IDC_HAND)
	wc.hbrBackground = GetSysColorBrush( %COLOR_WINDOW )
	wc.lpszMenuName =  0
	wc.lpszClassName = VarPtr(className)

	RegisterClass( wc )
End Sub

Function LinkLabel_GetUserData( ByVal hWnd As Dword) As Long
	Function = GetWindowLong(hWnd, 0)
End Function

Function LinkLabelCtlProc( ByVal hWnd As Dword, ByVal wMsg As Dword, ByVal wParam As Long, ByVal lParam As Long) As Long
	Select Case wMsg
		Case %WM_NCCreate:      Call LinkLabel_OnCreate(hWnd)
		Case %WM_Destroy:       Call LinkLabel_OnDestroy(hWnd)
		Case %WM_Paint:         Function = LinkLabel_OnPaint(hWnd): Exit Function
		Case %WM_EraseBkGnd:    Function = LinkLabel_OnDrawBackground( hWnd, wParam ): Exit Function
		Case %WM_MouseMove:     Call LinkLabel_OnMouseMove(hWnd)
		Case %WM_MouseHover:    Call LinkLabel_OnHover(hWnd, 1)
		Case %WM_MouseLeave:    Call LinkLabel_OnHover(hWnd, 0)
		Case %WM_LButtonDown:   Call LinkLabel_OnMouseDown(hWnd)
		Case %WM_Size:          Call LinkLabel_OnSize( hWnd, lParam )
		Case %LLM_GetForeColor: Function = LinkLabel_OnForeColor( hWnd ): Exit Function
		Case %LLM_GetBackColor: Function = LinkLabel_OnBackColor( hWnd ): Exit Function
		Case %LLM_SetColor:     Call LinkLabel_OnSetColor( hWnd, wParam, lParam ): Exit Function
	End Select
	Function = DefWindowProc( hWnd, wMsg, wParam, lParam )
End Function

Function LinkLabel_OnForeColor( ByVal hWnd As Dword ) As Long
	Local p As LinkLabelData Ptr
	p = LinkLabel_GetUserData( hWnd )
	If p=0 Then Function = 0: Exit Function
	Function = @p.foreColor
End Function

Function LinkLabel_OnBackColor( ByVal hWnd As Dword ) As Long
	Local p As LinkLabelData Ptr
	p = LinkLabel_GetUserData( hWnd )
	If p=0 Then Function=0: Exit Function
	Function = @p.backColor
End Function

Sub LinkLabel_OnSetColor( ByVal hWnd As Dword, foreColor As Long, backColor As Long )
	Local p As LinkLabelData Ptr
	p = LinkLabel_GetUserData( hWnd )
	If p=0 Then Exit Sub
	@p.foreColor = foreColor
	@p.backColor = backColor
End Sub

Sub LinkLabel_OnSize( ByVal hWnd As Dword, ByVal pSize As Long )
	Dim w As Long, h As Long
	Dim buf As AsciiZ*80
	Local hData As LinkLabelData Pointer
	Dim hdc As Long
	Dim t As String
	Dim pt As AsciiZ Ptr
	Dim sz As Size
	Dim ofn As Long

	Call LinkLabel_CreateFonts( hWnd )
	hData = LinkLabel_GetUserData(hWnd)
	If hData=0 Then Exit Sub
	If @hData.font = 0 Then Exit Sub

	w = Lo(Word, pSize)
	h = Hi(Word, pSize)
	GetWindowText( hWnd, buf, 80 )
	hdc = GetDC( hWnd )
	ofn = SelectObject( hdc, @hData.font )
	GetTextExtentPoint32( hdc, buf, Len(buf), sz )
	SelectObject( hdc, ofn )
	ReleaseDc( hWnd, hdc )
	If w<>sz.cx+9 Then
		SetWindowPos( hWnd, 0, 0, 0, sz.cx+9, h, %SWP_NOMOVE Or %SWP_NOZORDER )
	End If
End Sub

Sub LinkLabel_OnMouseDown( ByVal hWnd As Dword )
	Local hData As LinkLabelData Pointer
	Local i As Long
	Local buf As AsciiZ * 80

	hData = LinkLabel_GetUserData(hWnd)
	If hData=0 Then Exit Sub

	@hData.bdown = 1
	InvalidateRect( hWnd, ByVal %NULL, 0 )

	Thread Create LinkLabel_Flashing( hWnd ) To i
	Thread Close i To i

	GetWindowText( hWnd, buf, 80 )


	Local msg As LLCLICKED
	msg.hdr.code = %LLN_Clicked
	msg.hdr.idFrom = GetDlgCtrlID( hWnd )
	msg.hdr.hwndFrom = hWnd
	msg.pszKey = VarPtr(buf)
	SendMessage( GetParent(hWnd), %WM_Notify, hWnd, VarPtr(msg)  )
End Sub

Thread Function LinkLabel_Flashing(ByVal hWnd As Long) As Long
	Sleep(100)
	Local hData As LinkLabelData Pointer
	hData = LinkLabel_GetUserData(hWnd)
	If hData=0 Then Exit Function
	@hData.bdown = 0
	InvalidateRect( hWnd, ByVal %NULL, 0 )
End Function

Sub LinkLabel_OnMouseMove( hWnd As Dword )
	Local mouseEvent As TRACKMOUSEEVENTAPI
	mouseEvent.cbSize = SizeOf(mouseEvent)
	mouseEvent.dwFlags = %TME_HOVER Or %TME_LEAVE
	mouseEvent.hwndTrack = hwnd
	mouseEvent.dwHoverTime = 1: '%HOVER_DEFAULT
	TrackMouseEvent( mouseEvent )
End Sub

Sub LinkLabel_OnHover( ByVal hWnd As Dword, ByVal pHover As Long )
	Local hData As LinkLabelData Pointer
	hData = LinkLabel_GetUserData(hWnd)
	If hData=0 Then Exit Sub
	If pHover <> @hData.hover Then
		@hData.hover = pHover
		InvalidateRect( hWnd, ByVal %NULL, 0 )
	End If
End Sub

Function LinkLabel_OnDrawBackground( ByVal hWnd As Dword, hdc As Long ) As Long
	Function = 0
End Function

Function LinkLabel_OnPaint( ByVal hWnd As Dword ) As Long
	Local hData As LinkLabelData Pointer
	Local hdc As Long
	Local ps As PAINTSTRUCT
	Local fc As Long, bc As Long
	Local ofc, obc As Long
	Local rc As RECT
	Local br As Long
	Local pn As Long
	Local obr As Long
	Local opn As Long
	Local fn As Long
	Local ofn As Long
	Local buf As AsciiZ*80

	Function = 0
	hData = LinkLabel_GetUserData(hWnd)
	If hData=0 Then Exit Function

	hdc = BeginPaint( hWnd, ps )
	fc = @hData.foreColor
	bc = @hData.backColor
	If @hData.bdown Then
		Swap fc, bc
	End If
	If @hData.hover Then
		fn = @hData.hoverFont
	Else
		fn = @hData.font
	End If

	GetWindowText( hWnd, buf, 80 )
	GetClientRect( hWnd, rc )

	br = CreateSolidBrush( bc )
	pn = CreatePen( %PS_SOLID, 1, bc )
	obr = SelectObject(hdc, br)
	opn = SelectObject(hdc, pn)
	RoundRect( hdc, rc.Left, rc.Top, rc.Right, rc.Bottom, 8,8)
	SelectObject( hdc, obr)
	SelectObject( hdc, opn)
	DeleteObject(br)
	DeleteObject(pn)

	ofn = SelectObject(hdc, fn)
	ofc = SetTextColor( hdc, fc)
	obc = SetBkColor( hdc, bc )
	InflateRect(rc, -4, -1 )
	DrawText( hdc, buf, Len(buf), rc, %DT_LEFT Or %DT_NOPREFIX Or %DT_SINGLELINE )
	SetBkColor( hdc, obc )
	SetTextColor( hdc, ofc)
	SelectObject(hdc, ofn)
	EndPaint( hwnd, ps )
	Function = 0
End Function

Sub LinkLabel_OnCreate( ByVal hWnd As Dword )
	Local hData As LinkLabelData Pointer
	hData = GlobalAlloc( %GPTR, SizeOf(LinkLabelData))

	@hData.foreColor = RGB(0,0,255)
	@hData.backColor = RGB(255,255,233)
	@hData.hover = 0
	@hData.font = 0
	@hData.hoverFont = 0
	@hData.bdown = 0

	SetWindowLong( hWnd, 0, hData )

	Call LinkLabel_CreateFonts(hWnd)
End Sub
Sub LinkLabel_CreateFonts( ByVal hWnd As Dword)
	Local face As AsciiZ*20
	Local rc As RECT
	Local hData As LinkLabelData Pointer
	Local h As Long

	hData = LinkLabel_GetUserData(hWnd)
	If hData = 0 Then Exit Sub

	face = "Arial"
	If @hData.font Then DeleteObject( @hData.font )
	If @hData.hoverFont Then DeleteObject( @hData.hoverFont )

	GetClientRect( hWnd, rc )
	h = rc.bottom-2

	@hData.font = CreateFont(h,0,0,0, %FW_NORMAL, %FALSE, %FALSE, %FALSE, %DEFAULT_CHARSET, %OUT_DEFAULT_PRECIS, %CLIP_DEFAULT_PRECIS, %CLEARTYPE_QUALITY, %FF_DONTCARE, face )
	@hData.hoverFont = CreateFont(h,0,0,0, %FW_NORMAL, %FALSE, %TRUE, %FALSE, %DEFAULT_CHARSET, %OUT_DEFAULT_PRECIS, %CLIP_DEFAULT_PRECIS, %CLEARTYPE_QUALITY, %FF_DONTCARE, face )
End Sub

Sub LinkLabel_OnDestroy( ByVal hWnd As Dword )
	Local hData As LinkLabelData Pointer
	hData = LinkLabel_GetUserData(hWnd)
	If hData Then
		If @hData.font Then DeleteObject( @hData.font )
		If @hData.hoverFont Then DeleteObject( @hData.hoverFont )
		GlobalFree( hData )
	End If
End Sub
