#If Not %Def(%INCLUDE)
#Compile SLL
#Dim All
#Register All
#EndIf

#Include Once "Control.inc"
#Include Once "Win32Api.inc"

$WORDCLOUD_CLASS = "lcWordCloud"

Type WordCountPair
	key As AsciiZ*30
	cnt As Long
	h As Long
	w As Long
	lt As Long
	lh As Long
	f As Long
	rc As RECT
End Type

Global fonts() As Long
Global ulFonts() As Long
Global fontname As AsciiZ * 80
Global registerCnt As Long

Type WordCloudData
	pWc As WordCountPair Ptr
	ubWc As Long
	color1 As Long
	color2 As Long
	backColor As Long
	hImage As Dword
	index As Long
	rc As RECT
	eraseRc As RECT
	needCalc As Long
	needLayout As Long
	ignoreCnt As Long
	flash As Long
	pause As Long: ' wcPaintControl
	avg As Long
	sort As Long: ' wcSortType
	hover As Long
	strong As Long
End Type

Function NewWordCloud Alias "NewWordCloud"(ByVal hParent As Long, ByVal pLeft As Long, ByVal pTop As Long, ByVal pWidth As Long, ByVal pHeight As Long, ByVal controlId As Long) Export Common As Long
	Call WordCloudInit()

	Function = CreateWindowEx( 0, $WORDCLOUD_CLASS, "", %WS_Child Or %WS_Visible, pLeft, pTop, pWidth, pHeight, hParent, controlId, GetModuleHandle( ByVal 0), ByVal 0 )
End Function

Sub WordCloud_PaintControl Alias "WordCloud_PaintControl"( ByVal hWnd As Long, ByVal resumeOrSuspend As Long ) Common Export
	SendMessage( hWnd, %WCM_PaintControl, resumeOrSuspend, 0 ): ' Suspend updates
End Sub
Function WordCloud_GetPaintControl Alias "WordCloud_GetPaintControl" ( ByVal hWnd As Long ) Common Export As Long
	Function = SendMessage( hWnd, %WCM_GetPaintControl, 0, 0 )
End Function

Sub WordCloud_SetIgnoreCount Alias "WordCloud_SetIgnoreCount"( ByVal hWnd As Long, ByVal ignoreUpTo As Long ) Common Export
	SendMessage( hWnd, %WCM_IgnoreCount, ignoreUpTo, 0 ): ' Ignore words with count <= 1
End Sub

Function WordCloud_GetIgnoreCount Alias "WordCloud_GetIgnoreCount"( ByVal hWnd As Long ) Common Export As Long
	Function = SendMessage( hWnd, %WCM_GetIgnoreCount, 0, 0 ): ' Ignore words with count <= 1
End Function

Sub WordCloud_LoadFile Alias "WordCloud_LoadFile"( ByVal hWnd As Long, ByRef filename As AsciiZ ) Common Export
	SendMessage( hWnd, %WCM_Load, %wcLoadType.File, VarPtr(filename) ): ' Load text file of words
End Sub

Sub WordCloud_LoadText Alias "WordCloud_LoadText"( ByVal hWnd As Long, ByRef value As AsciiZ ) Common Export
	SendMessage( hWnd, %WCM_Load, %wcLoadType.Text, VarPtr(value) ): ' Load text file of words
End Sub

Sub WordCloud_AddFile Alias "WordCloud_AddFile"( ByVal hWnd As Long, ByRef filename As AsciiZ ) Common Export
	SendMessage( hWnd, %WCM_Add, %wcLoadType.File, VarPtr(filename) ): ' Add text file of words
End Sub

Sub WordCloud_AddText Alias "WordCloud_AddText"( ByVal hWnd As Long, ByRef value As AsciiZ ) Common Export
	SendMessage( hWnd, %WCM_Add, %wcLoadType.Text, VarPtr(value) ): ' Add text file of words
End Sub

Sub WordCloud_IgnoreFile Alias "WordCloud_IgnoreFile"( ByVal hWnd As Long, ByRef filename As AsciiZ ) Common Export
	SendMessage( hWnd, %WCM_Ignore, %wcLoadType.File, VarPtr(filename) ): ' Load a list of words to ignore
End Sub

Sub WordCloud_IgnoreText Alias "WordCloud_IgnoreText"( ByVal hWnd As Long, ByRef value As AsciiZ ) Common Export
	SendMessage( hWnd, %WCM_Ignore, %wcLoadType.Text, VarPtr(value) ): ' Load a list of words to ignore
End Sub

Sub WordCloud_Sort Alias "WordCloud_Sort"( ByVal hWnd As Long, ByVal sortType As Long ) Common Export
	SendMessage( hWnd, %WCM_Sort, sortType, 0 ): ' Sort by Frequency Descending
End Sub

Function WordCloud_GetSort Alias "WordCloud_GetSort"( ByVal hWnd As Long ) Common Export As Long
	Function = SendMessage( hWnd, %WCM_GetSort, 0, 0 )
End Function

Sub WordCloud_SetColor Alias "WordCloud_SetColor"( ByVal hWnd As Long, ByVal color1 As Long, ByVal backColor As Long, ByVal color2 As Long ) Common Export
	SendMessage( hWnd, %WCM_SetColor, color1,  backColor ): ' Set colors
	SendMessage( hWnd, %WCM_SetColor2, color2,  0 ): ' Set colors
End Sub

Function WordCloud_GetColor1 Alias "WordCloud_GetColor1"( ByVal hWnd As Long ) Common Export As Long
	Function = SendMessage( hWnd, %WCM_GetColor1, 0, 0 )
End Function

Function WordCloud_GetColor2 Alias "WordCloud_GetColor2"( ByVal hWnd As Long ) Common Export As Long
	Function = SendMessage( hWnd, %WCM_GetColor2, 0, 0 )
End Function

Function WordCloud_GetBackColor Alias "WordCloud_GetBackColor"( ByVal hWnd As Long ) Common Export As Long
	Function = SendMessage( hWnd, %WCM_GetBackColor, 0, 0 )
End Function

Sub WordCloud_SetFontname Alias "WordCloud_SetFontname" ( ByVal hWnd As Long, ByRef fontname As AsciiZ ) Common Export
	SendMessage( hWnd, %WCM_SetFontname, 0, VarPtr(fontname) )
End Sub

Function WordCloud_GetFontname Alias "WordCloud_GetFontname" ( ByVal hWnd As Long ) Common Export As Long
	Function = SendMessage( hWnd, %WCM_GetFontname, 0, 0 )
End Function


Function WordCloudCtlProc( ByVal hWnd As Dword, ByVal wMsg As Dword, ByVal wParam As Long, ByVal lParam As Long) As Long
	Select Case Const wMsg
		Case %WM_NCCreate:         Call WordCloud_OnCreate( hWnd )
		Case %WM_Destroy:          Call WordCloud_OnDestroy( hWnd )
		Case %WM_Size:             Call WordCloud_OnSize( hWnd, lParam )
		Case %WM_Paint:            Function = WordCloud_OnPaint( hWnd ): Exit Function
		Case %WM_LButtonDown:      Call WordCloud_OnClick( hWnd )
		Case %WM_MouseMove:        Call WordCloud_OnMouseMove( hWnd )
		Case %WM_MouseHover:       Call WordCloud_OnHover(hWnd, 1)
		Case %WM_MouseLeave:       Call WordCloud_OnHover(hWnd, 0)
		Case %WM_EraseBkGnd:       Function = WordCloud_OnDrawBackground( hWnd, wParam ): Exit Function

		Case %WCM_Add:             Call WordCloud_OnAdd( hWnd, wParam, lParam ): Exit Function
		Case %WCM_Load:            Call WordCloud_OnLoad( hWnd, wParam, lParam ): Exit Function
		Case %WCM_Ignore:          Call WordCloud_OnIgnore( hWnd, wParam, lParam ): Exit Function
		Case %WCM_Sort:            Call WordCloud_OnSetSort( hWnd, wParam ): Exit Function
		Case %WCM_GetSort:         Function = WordCloud_OnGetSort( hWnd ): Exit Function
		Case %WCM_SetColor:        Call WordCloud_OnSetColor( hWnd, wParam, lParam ): Exit Function
		Case %WCM_SetColor2:       Call WordCloud_OnSetColor2( hWnd, wParam ): Exit Function
		Case %WCM_GetColor1:       Function = WordCloud_OnGetColor1( hWnd ): Exit Function
		Case %WCM_GetBackColor:    Function = WordCloud_OnGetBackcolor( hWnd ): Exit Function
		Case %WCM_GetColor2:       Function = WordCloud_OnGetColor2( hWnd ): Exit Function
		Case %WCM_PaintControl:    Call WordCloud_OnPaintControl( hWnd, wParam ): Exit Function
		Case %WCM_GetPaintControl: Function = WordCloud_OnGetPaintControl( hWnd ): Exit Function
		Case %WCM_IgnoreCount:     Call WordCloud_OnSetIgnoreCount( hWnd, wParam ): Exit Function
		Case %WCM_GetIgnoreCount:  Function = WordCloud_OnGetIgnoreCount( hWnd ): Exit Function
		Case %WCM_GetFontname:     Function = WordCloud_OnGetFontname( hWnd ): Exit Function
		Case %WCM_SetFontname:     Call WordCloud_OnSetFontname( hWnd, lParam )
	End Select
	Function = DefWindowProc( hWnd, wMsg, wParam, lParam )
End Function

Function WordCloud_OnGetFontname( ByVal hWnd As Dword ) As Long
	Function = VarPtr(fontname)
End Function

Sub WordCloud_OnSetFontname( ByVal hWnd As Long,  ByVal pFontname As AsciiZ Ptr )
	Local p As WordCloudData Ptr
	Local i As Long
	Local freeFont As Long

	p = GetWordCloudData( hWnd )
	If p = 0 Then Exit Sub
	fontname = @pFontname

	If UBound(fonts())<0 Then
		ReDim fonts(20)
		ReDim ulFonts(20)
		freeFont = 0
	Else
		freeFont = -1
	End If
	For i=0 To 20
		If freeFont Then
			DeleteObject( fonts(i) )
			DeleteObject( ulFonts(i) )
		End If
		fonts(i) = CreateFont(16+i,0,0,0, %FW_NORMAL, %FALSE, %FALSE, %FALSE, %DEFAULT_CHARSET, %OUT_DEFAULT_PRECIS, %CLIP_DEFAULT_PRECIS, %CLEARTYPE_QUALITY, %FF_DONTCARE, fontname )
		ulFonts(i) = CreateFont(16+i,0,0,0, %FW_NORMAL, %FALSE, %TRUE, %FALSE, %DEFAULT_CHARSET, %OUT_DEFAULT_PRECIS, %CLIP_DEFAULT_PRECIS, %CLEARTYPE_QUALITY, %FF_DONTCARE, fontname )
	Next
	@p.needCalc = 1
	@p.needLayout = 1
	InvalidateRect( hWnd, ByVal %NULL, 1 )
End Sub
Function WordCloud_OnGetIgnoreCount( ByVal hWnd As Dword) As Long
	Local p As WordCloudData Ptr

	Function = 0
	p = GetWordCloudData( hWnd )
	If p = 0 Then Exit Function
	Function = @p.ignoreCnt
End Function
Sub WordCloud_OnSetIgnoreCount( ByVal hWnd As Dword, cnt As Long )
	Local p As WordCloudData Ptr

	p = GetWordCloudData( hWnd )
	If p = 0 Then Exit Sub
	@p.ignoreCnt = cnt
End Sub

Function WordCloud_OnGetPaintControl( ByVal hWnd As Dword ) As Long
	Local p As WordCloudData Ptr

	p = GetWordCloudData( hWnd )
	If p Then
		Function = @p.pause
	Else
		Function = %wcPaintControl.Resume
	End If
End Function
Sub WordCloud_OnPaintControl( ByVal hWnd As Dword, pType As Long )
	Local p As WordCloudData Ptr

	p = GetWordCloudData( hWnd )
	If p = 0 Then Exit Sub
	@p.pause = pType
	If @p.pause = %wcPaintControl.Resume Then
		InvalidateRect( hWnd, ByVal %NULL, 1 )
	End If
End Sub
Sub WordCloud_OnSetColor( ByVal hWnd As Dword, color1 As Long, backColor As Long )
	Local p As WordCloudData Ptr

	p = GetWordCloudData( hWnd )
	If p = 0 Then Exit Sub

	If @p.color1<>color1 Or @p.backColor<>backColor Then
		@p.color1 = color1
		@p.backColor = backColor
		InvalidateRect( hWnd, ByVal %NULL, 0 )
	End If
End Sub
Sub WordCloud_OnSetColor2( ByVal hWnd As Dword, color2 As Long )
	Local p As WordCloudData Ptr

	p = GetWordCloudData( hWnd )
	If p = 0 Then Exit Sub

	If @p.color2<>color2 Then
		@p.color2 = color2
		InvalidateRect( hWnd, ByVal %NULL, 0 )
	End If
End Sub
Function WordCloud_OnGetColor2( ByVal hWnd As Dword ) As Long
	Local p As WordCloudData Ptr

	p = GetWordCloudData( hWnd )
	If p = 0 Then
		Function=0
	Else
		Function = @p.color2
	End If
End Function
Function WordCloud_OnGetColor1( ByVal hWnd As Dword ) As Long
	Local p As WordCloudData Ptr

	p = GetWordCloudData( hWnd )
	If p = 0 Then
		Function=0
	Else
		Function = @p.color1
	End If
End Function
Function WordCloud_OnGetBackcolor( ByVal hWnd As Dword ) As Long
	Local p As WordCloudData Ptr

	p = GetWordCloudData( hWnd )
	If p = 0 Then
		Function = 0
	Else
		Function = @p.backColor
	End If
End Function

Sub WordCloud_OnClick( ByVal hWnd As Dword )
	Local p As WordCloudData Ptr
	Local i As Long
	Local e As AsciiZ * 3
	e = ""

	p = GetWordCloudData( hWnd )
	If p = 0 Then Exit Sub
	If @p.index=0 And @p.rc.Left = 0 Then Exit Sub: ' No hit
	@p.flash = 1
	InvalidateRect( hWnd, @p.rc, 0 )

	Thread Create WordCloud_Flashing( hWnd ) To i
	Thread Close i To i
	Local msg As WCCLICKED
	msg.hdr.code = %WCN_Clicked
	msg.hdr.idFrom = GetDlgCtrlID( hWnd )
	msg.hdr.hwndFrom = hWnd
	If @p.pWc Then
		msg.cnt = @p.@pWc[@p.index].cnt
		msg.pszKey = VarPtr(@p.@pWc[@p.index].key)
	Else
		msg.cnt = 0
		msg.pszKey = VarPtr(e)
	End If
	SendMessage( GetParent(hWnd), %WM_Notify, hWnd, VarPtr(msg)  )
End Sub

Thread Function WordCloud_Flashing( ByVal hWnd As Long ) As Long
	Local p As WordCloudData Ptr
	Local rc As RECT

	p = GetWordCloudData( hWnd )
	If p = 0 Then Exit Function
	CopyRect( rc, @p.rc )

	Sleep(150)

	Function = 0
	@p.flash = 0
	InvalidateRect( hWnd, rc, 0 )
End Function

Sub WordCloud_OnHover( ByVal hWnd As Dword, ByVal pHover As Long )
	Local p As WordCloudData Ptr
	p = GetWordCloudData( hWnd )
	If p=0 Then Exit Sub
	If pHover <> @p.hover Then
		@p.hover = pHover
		InvalidateRect( hWnd, @p.rc, 0 )
	End If
End Sub

Sub WordCloud_OnMouseMove( ByVal hWnd As Dword )
	Local rc As RECT
	Local cursor As Point
	Local p As WordCloudData Ptr
	Local i As Long

	p = GetWordCloudData( hWnd )
	If p=0 Then Exit Sub
	If @p.rc.Left Then
		InvalidateRect( hWnd, @p.rc, 0 )
	End If

	GetCursorPos(cursor)
	MapWindowPoints( %NULL, hWnd, VarPtr(cursor), 1 )
	For i=0 To @p.ubWc
		If cursor.x>=@p.@pWc[i].rc.Left And cursor.x<=@p.@pWc[i].rc.Right And cursor.y>=@p.@pWc[i].rc.top And cursor.y<=@p.@pWc[i].rc.Bottom Then
			InvalidateRect( hWnd, @p.@pWc[i].rc, 0 )
		End If
	Next

	Local mouseEvent As TRACKMOUSEEVENTAPI
	mouseEvent.cbSize = SizeOf(mouseEvent)
	mouseEvent.dwFlags = %TME_HOVER Or %TME_LEAVE
	mouseEvent.hwndTrack = hwnd
	mouseEvent.dwHoverTime = 1: '%HOVER_DEFAULT
	TrackMouseEvent( mouseEvent )
End Sub

Function WordCloud_OnDrawBackground( ByVal hWnd As Dword, hdc As Long ) As Long
	Function = 0
End Function

Function WordCloud_OnSize( ByVal hWnd As Dword, ByVal lParam As Long ) As Long
	Local p As WordCloudData Ptr
	Function = 0
	p = GetWordCloudData( hWnd )
	If p = 0 Then Exit Function
	@p.needLayout = 1
	InvalidateRect( hWnd, ByVal %NULL, 0 )
End Function

Function WordCloud_OnPaint( ByVal hWnd As Dword ) As Long
	Local rc As RECT
	Local hdc As Long
	Local ps As PAINTSTRUCT
	Local p As WordCloudData Ptr
	Local cursor As Point
	Local hit As Long
	Local i As Long
	Local ofn As Long
	Local ubWords As Long
	Local lpcsz As AsciiZ Ptr
	Local br As Dword
	Local pn As Dword
	Local obr As Long
	Local opn As Long
	Local bbr As Long
	Local img As Long
	Local mhdc As Long
	Local rgn As Long
	Local fidx As Long
	Local lastHit As Long

	Function = 0
	p = GetWordCloudData( hWnd )
	If p = 0 Then Exit Function
	If @p.pause Then Exit Function

	If @p.pWc And @p.ubWc>-1 Then
		If @p.needCalc Then Call CalcWordSize( hWnd, @p.pWc, @p.ubWC )
		If @p.needLayout Then Call LayoutWords( hWnd, @p.pWc, @p.ubWC )
	End If

	rgn = CreateRectRgn(0,0,0,0)
	GetUpdateRgn( hWnd, rgn, 1 )

	hdc = BeginPaint( hWnd, ps )
	ubWords = @p.ubWC

	GetCursorPos(cursor)
	MapWindowPoints( %NULL, hWnd, VarPtr(cursor), 1 )

	bbr = CreateSolidBrush( @p.backColor )
	GetClientRect( hWnd, rc )

	img = CreateCompatibleBitmap(hdc, rc.right, rc.bottom)
	mhdc = CreateCompatibleDC(hdc)

	SelectObject( mhdc, img )
	SetTextColor( mhdc, @p.color1 )
	SetBkColor( mhdc, @p.backColor )
	SetBkMode( mhdc, %OPAQUE )

	SelectClipRgn( mhdc, rgn )

	FillRect( mhdc, rc, bbr ): ' Erase the area

	Local l,t,r,b As Long
	lastHit = @p.index
	@p.eraseRc.Left = 0
	If @p.pWc And @p.ubWc>-1 Then
		For i=0 To ubWords
			hit = 0
			If @p.color2 Then
				If @p.@pWc[i].cnt >= @p.strong Then
					SetTextColor( mhdc, @p.color2 )
				Else
					SetTextColor( mhdc, @p.color1 )
				End If
			End If
			lpcsz = VarPtr( @p.@pWc[i].key )
			CopyRect( rc, @p.@pWc[i].rc )
			If RectVisible( hdc, rc ) = 0 Then Iterate For
			If cursor.x>=rc.Left And cursor.x<=rc.Right And cursor.y>=rc.Top And cursor.y<=rc.Bottom Then
				hit = 1
				@p.index = i
				CopyRect( @p.eraseRc, rc )
				CopyRect( @p.rc, rc )
			End If

			fidx = Min&( Max&( @p.@pWc[i].f, 0 ), UBound(fonts()) )
			If fidx>=0 And fidx<=20 Then SelectObject( mhdc, IIf&(hit, ulFonts( fidx ), fonts( fidx ) ) )

			' Draw a rect if needed
			If @p.flash And hit Then
				' If Mouse Down
				br = CreateSolidBrush( @p.color1 )
				pn = CreatePen( %PS_SOLID, 1, @p.color1 )
				obr = SelectObject( mhdc, br )
				opn = SelectObject( mhdc, pn )
				RoundRect( mhdc, rc.Left, rc.Top, rc.Right, rc.Bottom, 8, 8 )
				SelectObject( mhdc, opn )
				SelectObject( mhdc, obr )
				DeleteObject( br )
				DeleteObject( pn )

				SetTextColor( mhdc, @p.backColor )
				SetBkColor( mhdc, @p.color1 )
			End If
			InflateRect( rc, -4, -1 )
			' Draw text
			DrawText( mhdc, @lpcsz, Len(@lpcsz), rc, %DT_LEFT Or %DT_NOPREFIX Or %DT_SINGLELINE)

			If @p.flash And hit Then
				SetTextColor( mhdc, @p.color1 )
				SetBkColor( mhdc, @p.backColor )
			End If
		Next i
	End If

	GetClientRect( hWnd, rc )

	SelectClipRgn( hdc, rgn )
	Call BitBlt( hdc, 0,0,rc.right,rc.bottom, mhdc, 0, 0, %SRCCOPY )
	DeleteObject( rgn )
	DeleteDc( mhdc )
	DeleteObject( img )
	DeleteObject( bbr )
	EndPaint( hwnd, ps )
End Function

Sub WordCloud_OnAdd( ByVal hWnd As Dword, ByVal pType As Long, ByVal pVal As AsciiZ Ptr )
	Local vVal As String
	Local words() As WordCountPair
	Local p As WordCloudData Ptr
	Local i As Long

	p = GetWordCloudData( hWnd )
	If p = 0 Then Exit Sub

	vVal = @pVal
	If pType=%wcLoadType.File Then vVal = ReadAllText( vVal )
	If @p.ubWC>-1 And @p.pWc Then
		ReDim words(@p.ubWC)
		For i=0 To @p.ubWC
			words(i) = @p.@pWc[i]
		Next
	End If

	Call AddWords( hWnd, vVal, words() )
	@p.needCalc = 1
	@p.needLayout = 1
	Call WordCloud_SetWords( hWnd, words() )
	InvalidateRect( hWnd, ByVal %NULL, 0 )
End Sub
Sub WordCloud_OnLoad( ByVal hWnd As Dword, ByVal pType As Long, ByVal pVal As AsciiZ Ptr )
	Local vVal As String
	Local words() As WordCountPair

	vVal = @pVal
	If pType=%wcLoadType.File Then vVal = ReadAllText( vVal )

	Call CountWords( hWnd, vVal, words() )
	Local ub As Long
	ub = UBound(words())

	Local p As WordCloudData Ptr
	p = GetWordCloudData( hWnd )
	If p Then
		@p.needCalc = 1
		@p.needLayout = 1
	End If
	Call WordCloud_SetWords( hWnd, words() )
	InvalidateRect( hWnd, ByVal %NULL, 0 )
End Sub

Sub LayoutWords( ByVal hWnd As Long, ByVal wordPtr As Long, ByVal ubWords As Long)
	Local words As WordCountPair Ptr
	Local rc As RECT
	Local x As Long
	Local y As Long
	Local lh As Long
	Local cLine As Long
	Local i As Long
	Local j As Long
	Local sl As Long
	Local s As Double
	Local ofs As Double
	Local p As WordCloudData Ptr

	p = GetWordCloudData( hWnd )
	If p = 0 Then Exit Sub
	If wordPtr = 0 Then Exit Sub
	If ubWords < 0 Then Exit Sub
	words = wordPtr
	Call GetClientRect( hWnd, rc )
	x = 5
	y = 5
	lh = 0
	cLine = 0
	For i=0 To ubWords
		If x + @words[i].w + 5 > rc.right Then
			s = CDbl(rc.right - x - 6) / CDbl(i-sl-1): ' Space between each word
			ofs = 0
			For j=sl To i-1
				If j=i-1 And j>sl Then
					' Ensure the right marjin is crisp (i.e. remove any rounding errors)
					ofs = rc.right-6-(@words[j].rc.Right-@words[j].rc.Left) - @words[j].rc.Left
				End If
				If ofs Then OffsetRect( @words[j].rc, CInt(ofs), 0 )
				ofs += s
				@words[j].lh = lh
				@words[j].lt = y
				If lh > @words[j].h Then OffsetRect( @words[j].rc, 0, (lh - @words[j].h)/2 )
			Next
			x = 5
			y += lh
			lh = 0
			sl = i
		End If
		@words[i].rc.Left = x
		@words[i].rc.Top = y
		@words[i].rc.Right = x + @words[i].w
		@words[i].rc.Bottom = y + @words[i].h
		If @words[i].h > lh Then lh = @words[i].h
		x += @words[i].w
	Next
	For j=sl To ubWords
		@words[j].lh = lh
		@words[j].lt = y
		If lh > @words[j].h Then OffsetRect( @words[j].rc, 0, (lh - @words[j].h)/2 )
	Next

	@p.needLayout = 0
End Sub

Sub CalcWordSize( ByVal hWnd As Dword, ByVal wordPtr As Long, ByVal ubWords As Long)
	Local small As Long, big As Long, rng As Double
	Local i As Long
	Local hFont As Long
	Local f As Long, ofn As Long
	Local h As Long
	Local lpcsz As AsciiZ Ptr
	Local hdc As Long
	Local rc As RECT
	Local words As WordCountPair Ptr
	Local avg As Double
	Local cnt As Long
	Local p As WordCloudData Ptr

	p = GetWordCloudData( hWnd )
	If p = 0 Then Exit Sub
	If wordPtr = 0 Then Exit Sub
	If ubWords < 0 Then Exit Sub

	words = wordPtr

	small=9999
	big =0
	For i = 0 To ubWords
		If @words[i].cnt < small Then small = @words[i].cnt
		If @words[i].cnt > big Then big = @words[i].cnt
		avg += @words[i].cnt
		Incr cnt
	Next
	avg /= CDbl(cnt)
	avg = CInt(avg)
	Local lor As Double
	Local hir As Double
	@p.avg = avg

	lor = 10# / CDbl( avg - small + 1 )
	hir = 10# / CDbl( big - avg + 1 )
	rng = CDbl( big - small + 1 )
	'@p.strong = (big-avg)/2+avg
	If rng>0 Then rng = 20# / rng

	hdc = GetDC( hWnd )
	ofn = SelectObject( hdc, fonts(0) )
	For i=0 To ubWords
		lpcsz = VarPtr( @words[i].key )
		If @words[i].cnt < avg Then
			f = ( @words[i].cnt - small ) * lor
		Else
			f = ( @words[i].cnt - avg ) * hir + 10
		End If
		h = f + 16
		SelectObject( hdc, fonts(f) )
		DrawText( hdc, @words[i].key, Len(@words[i].key), rc, %DT_LEFT Or %DT_NOPREFIX Or %DT_SINGLELINE Or %DT_CALCRECT Or %DT_NOCLIP)
		rc.Right += 8
		rc.Bottom += 2
		@words[i].f = f
		@words[i].h = rc.bottom
		@words[i].w = rc.right
		CopyRect( @words[i].rc, rc )
	Next
	SelectObject( hdc, ofn )
	ReleaseDC( hWnd, hdc )
	@p.needCalc = 0
End Sub

Sub WordCloud_OnIgnore( ByVal hWnd As Dword, ByVal pType As Long, ByVal pVal As AsciiZ Ptr )
	Local vIgnore As String
	Local ubWords As Long
	Local words As WordCountPair Pointer

	words = WordCloud_GetWords( hWnd, ubWords )
	If words = 0 Then Exit Sub
	vIgnore = @pVal
	If pType=%wcLoadType.File Then vIgnore = ReadAllText( vIgnore )

	Dim words2(ubWords) As WordCountPair
	Local i As Long
	For i=0 To ubWords
		words2(i) = @words[i]
	Next

	Call RemoveWords( vIgnore, words2() )
	Call WordCloud_SetWords( hWnd, words2() )
	Local p As WordCloudData Ptr
	p = GetWordCloudData( hWnd )
	If p Then
		@p.needCalc = 1
		@p.needLayout = 1
	End If
	InvalidateRect( hWnd, ByVal %NULL, 0 )
End Sub

Function WordCloud_OnGetSort( ByVal hWnd As Dword ) As Long
	Local p As WordCloudData Ptr
	p = GetWordCloudData( hWnd )
	If p Then
		Function = @p.sort
	Else
		Function = %wcSortType.Name
	End If
End Function

Sub WordCloud_OnSetSort( ByVal hWnd As Dword, ByVal pType As Long )
	Local ubWords As Long
	Local words As WordCountPair Pointer
	Local p As WordCloudData Ptr

	' Ensure pType is valid
	Select Case Const pType
		Case %wcSortType.NameDesc, %wcSortType.Freq, %wcSortType.FreqDesc, %wcSortType.Length, %wcSortType.LengthDesc
			' Nothing
		Case Else
			pType = %wcSortType.Name
	End Select

	p = GetWordCloudData( hWnd )
	If p Then
		@p.sort = pType
	End If
	words = WordCloud_GetWords( hWnd, ubWords )
	If words = 0 Or ubWords<0 Then Exit Sub

	Dim words2(ubWords) As WordCountPair
	Local i As Long
	For i=0 To ubWords
		words2(i) = @words[i]
	Next
	Select Case Const pType
		Case %wcSortType.Name:       Array Sort words2(), Call WordCountByName()
		Case %wcSortType.NameDesc:   Array Sort words2(), Call WordCountByNameDesc()
		Case %wcSortType.Freq:       Array Sort words2(), Call WordCountByFreq()
		Case %wcSortType.FreqDesc:   Array Sort words2(), Call WordCountByFreqDesc()
		Case %wcSortType.Length:     Array Sort words2(), Call WordCountByLength()
		Case %wcSortType.LengthDesc: Array Sort words2(), Call WordCountByLengthDesc()
	End Select

	If p Then
		@p.needLayout = 1
	End If
	Call WordCloud_SetWords( hWnd, words2() )

	InvalidateRect( hWnd, ByVal %NULL, 0 )
End Sub

Sub WordCloud_OnCreate( ByVal hWnd As Dword )
	Local p As WordCloudData Ptr

	p = GlobalAlloc(%GPTR, SizeOf( WordCloudData ) )
	@p.pWc = 0
	@p.ubWC = -1
	@p.color1 = GetSysColor( %COLOR_WINDOWTEXT )
	@p.color2 = GetSysColor( %COLOR_ACTIVECAPTION )
	@p.backColor = GetSysColor( %COLOR_3DFACE )
	@p.hImage = 0
	@p.index = 0
	@p.rc.Left = 0

	@p.needCalc = 0
	@p.needLayout = 0
	@p.ignoreCnt = 0
	@p.flash = 0
	@p.pause = 0
	@p.avg = 0
	@p.sort = %wcSortType.Name
	@p.strong = 0

	Call SetWordCloudData( hWnd, p )
	Incr registerCnt
End Sub

Sub WordCloud_OnDestroy( ByVal hWnd As Dword )
	Local p As WordCloudData Ptr
	Local i As Long

	Call WordCloud_ReleaseMem( hWnd )

	p = GetWordCloudData( hWnd )
	If p Then GlobalFree( p )
	SetWordCloudData( hWnd, 0 )
	Decr registerCnt
	If registerCnt = 0 Then
		UnregisterClass( $WORDCLOUD_CLASS, GetModuleHandle( ByVal 0 ) )

		If UBound(fonts())>-1 Then
			For i=0 To 20
				DeleteObject( fonts(i) )
				DeleteObject( ulFonts(i) )
			Next

			Erase fonts()
			Erase ulFonts()
		End If
	End If
End Sub

Function GetWordCloudData( ByVal hWnd As Dword) As Long
	Function = GetWindowLong(hWnd, 0)
End Function

Sub SetWordCloudData( ByVal hWnd As Dword, ByVal value As Long)
	Call SetWindowLong(hWnd, 0, value)
End Sub

Sub WordCloudInit()
	Local className As AsciiZ*20
	Local wc As WNDCLASS
	Local i As Long

	fontname = "Arial"
	className = $WORDCLOUD_CLASS

	If GetClassInfo(%NULL, $WORDCLOUD_CLASS, wc) Then Exit Sub: ' Already registered

	ReDim fonts(20) As Long
	ReDim ulfonts(20) As Long
	For i=0 To 20
		fonts(i) = CreateFont(16+i,0,0,0, %FW_NORMAL, %FALSE, %FALSE, %FALSE, %DEFAULT_CHARSET, %OUT_DEFAULT_PRECIS, %CLIP_DEFAULT_PRECIS, %CLEARTYPE_QUALITY, %FF_DONTCARE, fontname )
		ulFonts(i) = CreateFont(16+i,0,0,0, %FW_NORMAL, %FALSE, %TRUE, %FALSE, %DEFAULT_CHARSET, %OUT_DEFAULT_PRECIS, %CLIP_DEFAULT_PRECIS, %CLEARTYPE_QUALITY, %FF_DONTCARE, fontname )
	Next

	' Register class for lcWordCloud window
	wc.style = %CS_GLOBALCLASS
	wc.lpfnWndProc = CodePtr( WordCloudCtlProc )
	wc.cbClsExtra = 0
	wc.cbWndExtra = SizeOf(i): ' Pointer to WordCountData
	wc.hInstance = GetModuleHandle( ByVal 0 )
	wc.hIcon = %NULL
	wc.hCursor = LoadCursor(%NULL, ByVal %IDC_ARROW)
	wc.hbrBackground = CreateSolidBrush(RGB(255,255,233))
	wc.lpszMenuName =  0
	wc.lpszClassName = VarPtr(className)

	Call RegisterClass( wc )
End Sub

Sub WordCloud_ReleaseMem( ByVal hWnd As Dword )
	Local p As WordCloudData Ptr

	p = GetWordCloudData( hWnd )
	If p Then
		If @p.pWc Then GlobalFree(@p.pWc)
		@p.pWc = 0
		@p.ubWC = -1
	End If
End Sub

Function WordCloud_GetWords( ByVal hWnd As Dword, ByRef ubWords As Long ) As Long
	Local p As WordCloudData Ptr

	Function = 0
	p = GetWordCloudData( hWnd )
	If p = 0 Then Exit Function

	ubWords = @p.ubWC
	Function = @p.pWc
End Function

Sub WordCloud_SetWords( ByVal hWnd As Dword, ByRef words() As WordCountPair )
	Local p As WordCloudData Ptr
	Local i As Long
	Local ubWords As Long

	p = GetWordCloudData( hWnd )
	If p = 0 Then Exit Sub

	ubWords = UBound(words())
	If UBound(Words())-LBound(Words())=-1 Then
		Call WordCloud_ReleaseMem( hWnd )
		Exit Sub
	End If
	If ubWords > @p.ubWC Or @p.pWc = 0 Then
		Call WordCloud_ReleaseMem( hWnd )
		@p.pWc = GlobalAlloc(%GPTR, SizeOf( WordCountPair ) * ( ubWords+1 ) )
	End If

	For i = 0 To ubWords
		@p.@pWc[i] = words(i)
	Next
	@p.ubWC = ubWords
End Sub

Function WordCountByFreq( ByRef a As WordCountPair, ByRef b As WordCountPair) As Long
	If a.cnt < b.cnt Then
		Function = -1
	ElseIf a.cnt > b.cnt Then
		Function = 1
	ElseIf a.key < b.key Then
		Function = -1
	ElseIf a.key > b.key Then
		Function = 1
	Else
		Function = 0
	End If
End Function

Function WordCountByName( ByRef a As WordCountPair, ByRef b As WordCountPair) As Long
	If a.key < b.key Then
		Function = -1
	ElseIf a.key > b.key Then
		Function = 1
	Else
		Function = 0
	End If
End Function

Function WordCountByLength( ByRef a As WordCountPair, ByRef b As WordCountPair ) As Long
	If Len( a.key ) < Len( b.key ) Then
		Function = -1
	ElseIf Len( a.key ) > Len( b.key ) Then
		Function = 1
	ElseIf a.key < b.key Then
		Function = -1
	ElseIf a.key > b.key Then
		Function = 1
	Else
		Function = 0
	End If
End Function

Function WordCountByLengthDesc( ByRef a As WordCountPair, ByRef b As WordCountPair ) As Long
	Function = -WordCountByLength( a, b )
End Function

Function WordCountByFreqDesc( ByRef a As WordCountPair, ByRef b As WordCountPair) As Long
	Function = -WordCountByFreq(a,b)
End Function

Function WordCountByNameDesc( ByRef a As WordCountPair, ByRef b As WordCountPair) As Long
	Function = -WordCountByName(a,b)
End Function

Function ReadAllText( ByVal filename As String ) As String
	Local vText As String
	If Dir$(filename) <> "" Then
		Open filename For Binary As #1
		Get$ #1, Lof(1), vText
		Close #1
	End If
	Function = vText
End Function

Sub AddWords( ByVal hWnd As Long, ByVal pText As String, ByRef words() As WordCountPair )
	Local vValidChars As String
	Local vSpaceChars As String
	Local vWords() As String
	Local nWords() As WordCountPair
	Local i As Long
	Local mx As Long
	Local mx2 As Long
	Local cnt As Long
	Local last As String
	Local j As Long
	Local nx As Long
	Local p As WordCloudData Ptr

	p = GetWordCloudData( hWnd )
	If p = 0 Then Exit Sub

	vValidChars = Chr$(65 To 90) + Chr$(97 To 122) + "_": ' Alpha, Numeric, Underscore by default
	vSpaceChars = Remove$( Chr$(1 To 255), Any vValidChars+" " )

	Replace Any vSpaceChars With Space$(Len(vSpaceChars)) In pText
	Replace "  " With " " In pText
	Replace "  " With " " In pText
	Replace "  " With " " In pText
	pText = Trim$(LCase$(pText))
	If Len(pText)=0 Then Exit Sub

	ReDim vWords( ParseCount( pText, " ")-1 )
	Parse pText, vWords(), " "
	Array Sort vWords()

	last = ""
	mx = UBound(vWords())
	ReDim nWords(mx)

	For i=0 To mx
		If last<>vWords(i) Then
			' To include rare words or not, that is the question...
			If Len(last)>0 And cnt>@p.ignoreCnt Then
				nWords(j).key=last
				nWords(j).cnt=cnt
				Incr j
			End If
			cnt=0
			last=vWords(i)
		End If
		Incr cnt
	Next
	nWords(j).key=last
	nWords(j).cnt=cnt
	ReDim Preserve nWords(j)

	Array Sort nWords(), Call WordCount_ByName()
	If UBound(words())>=0 Then
		Array Sort words(), Call WordCount_ByName()
		Dim v As String
		v =words(0)
	End If

	mx2 = j
	mx = UBound(words())
	i=0
	j=0
	nx = mx
	While i<mx And j<mx2
		If nWords(j).key = words(i).key Then
			words(i).cnt += nWords(j).cnt
			Incr i
			Incr j
		ElseIf nWords(j).key < words(i).key Then
			If nx>=UBound(words()) Then
				ReDim Preserve words(UBound(words())+100)
			End If
			Incr nx
			words(nx).key = nWords(j).key
			words(nx).cnt = nWords(j).cnt
			Incr j
		Else
			Incr i
		End If
	Wend
	While j<=mx2
		If nx+1>=UBound(words()) Then
			ReDim Preserve words(UBound(words())+100)
		End If
		Incr nx
		words(nx).key = nWords(j).key
		words(nx).cnt = nWords(j).cnt
		Incr j
	Wend
	ReDim Preserve words(nx)
	Array Sort words(), Call WordCountByFreq()
	@p.strong = words( UBound(words())*.9 ).cnt
	@p.sort = %wcSortType.Name
	Array Sort words(), Call WordCount_ByName()
End Sub
Sub CountWords( ByVal hWnd As Long, ByVal pText As String, ByRef words() As WordCountPair )
	Local vValidChars As String
	Local vSpaceChars As String
	Local vWords() As String
	Local i As Long
	Local mx As Long
	Local cnt As Long
	Local last As String
	Local j As Long
	Local p As WordCloudData Ptr

	p = GetWordCloudData( hWnd )
	If p = 0 Then Exit Sub

	vValidChars = Chr$(65 To 90) + Chr$(97 To 122) + "_": ' Alpha, Numeric, Underscore by default
	vSpaceChars = Remove$( Chr$(1 To 255), Any vValidChars+" " )

	Replace Any vSpaceChars With Space$(Len(vSpaceChars)) In pText
	Replace "  " With " " In pText
	Replace "  " With " " In pText
	Replace "  " With " " In pText
	pText = Trim$(LCase$(pText))
	If Len(pText)=0 Then Exit Sub

	ReDim vWords( ParseCount( pText, " ")-1 )
	Parse pText, vWords(), " "
	Array Sort vWords()

	last = ""
	mx = UBound(vWords())
	ReDim words(mx)

	For i=0 To mx
		If last<>vWords(i) Then
			' To include rare words or not, that is the question...
			If Len(last)>0 And cnt>@p.ignoreCnt Then
				words(j).key=last
				words(j).cnt=cnt
				Incr j
			End If
			cnt=0
			last=vWords(i)
		End If
		Incr cnt
	Next
	words(j).key=last
	words(j).cnt=cnt
	ReDim Preserve words(j)
	Array Sort words(), Call WordCountByFreq()
	@p.strong = words( UBound(words())*.9 ).cnt
	@p.sort = %wcSortType.Name
	Array Sort words(), Call WordCount_ByName()
End Sub

Sub RemoveWords( ByVal pIgnore As String, ByRef words() As WordCountPair )
	Local vValidChars As String
	Local vSpaceChars As String
	Local vIgnore() As String
	Local i As Long
	Local j As Long
	Local k As Long
	Local mxW As Long
	Local mxI As Long

	If Len(Trim$(pIgnore))=0 Then Exit Sub
	If UBound(words())-LBound(words())=-1 Then Exit Sub

	vValidChars = Chr$(65 To 90) + Chr$(97 To 122) + Chr$(48 To 57) + "_": ' Alpha, Numeric, Underscore by default
	vSpaceChars = Remove$( Chr$(1 To 255), Any vValidChars+" " )

	Replace Any vSpaceChars With Space$(Len(vSpaceChars)) In pIgnore
	Replace "  " With " " In pIgnore
	Replace "  " With " " In pIgnore
	pIgnore = LCase$(pIgnore)
	ReDim vIgnore( ParseCount( pIgnore, " ")-1 )
	Parse pIgnore, vIgnore(), " "
	Array Sort vIgnore()
	mxW = UBound(words())
	mxI = UBound(vIgnore())
	Array Sort words(), Call WordCount_ByName()
	While i<=mxW And j<=mxI
		If words(i).key="zero" Or vIgnore(j)="zero" Then
			i=i
		End If
		If words(i).key = vIgnore(j) Then
			'Remove word
			Decr mxW
			For k=i To mxW
				words(k)=words(k+1)
			Next
		ElseIf words(i).key < vIgnore(j) Then
			Incr i
		Else
			Incr j
		End If
	Wend
	ReDim Preserve words(mxW)
End Sub

Function WordCount_ByName( a As WordCountPair, b As WordCountPair) As Long
	If a.key < b.key Then
		Function = -1
	ElseIf a.key > b.key Then
		Function = 1
	Else
		Function = 0
	End If
End Function
