#Compile Exe
#Dim All

%INCLUDE=1
'%LIBRARY=1
#Include Once "ControlLib.inc"
#Include "Win32Api.inc"

#Resource Manifest,     1, "main.xml"

$WIN_CLASS = "lcDemoWin"
%CTL_LINK   = 101
%CTL_STATUS = 102
%CTL_SORT   = 103
%CTL_WC     = 104

Function PBMain () As Long
	Local hWnd As Dword
	Local hChild As Dword
	Local hChild2 As Dword
	Local rc As RECT
	Local filename As AsciiZ*40
	Local fontname As AsciiZ*80
	Dim sorts(5) As String
	Local hCmb As Dword
	Local hStatus As Dword

	Array Assign sorts() = "Name", "Name descending", "Frequency", "Frequency descending", "Length", "Length descending"

	Call Initialize()

	hWnd = CreateWindowEx( 0, $WIN_CLASS, "Demo Controls", %WS_OverlappedWindow Or %WS_Visible, %CW_USEDEFAULT, %CW_USEDEFAULT, 640, 480, %NULL, 0, GetModuleHandle(ByVal 0), ByVal 0 )

	GetClientRect(hWnd, rc)

	hStatus = CreateWindowEx( %WS_Ex_ClientEdge, "static", "", %WS_Child Or %WS_Visible, 120, 4, 150, 23, hWnd, %CTL_STATUS, GetModuleHandle(ByVal 0), ByVal 0 )

	hChild2 = NewLinkLabel( hWnd, "Test", 4, 4, 23, %CTL_LINK)

	hCmb = CreateWindowEx( %WS_Ex_ClientEdge, "COMBOBOX", "Name", %WS_VScroll Or %CBS_HasStrings Or %CBS_DropDownList Or %WS_Child Or %WS_Visible Or %WS_TabStop, rc.Right-150-5, 4, 150, 161, hWnd, %CTL_SORT, GetModuleHandle(ByVal 0), ByVal 0 )
	Local i As Long
	For i=0 To 5
		SendMessage( hCmb, %CB_ADDSTRING, 0, ByVal StrPtr(sorts(i)) )
	Next
	SendMessage( hCmb, %CB_SETCURSEL, 0, 0 )

	hChild = NewWordCloud(hWnd, 0, 30, rc.Right, rc.Bottom-30, %CTL_WC )

	Call WordCloud_PaintControl(hChild, %wcPaintControl.Suspend)

	'fontname = "Arial Rounded MT Bold"
	fontname = "Times New Roman"
	Call WordCloud_SetFontname( hChild, fontname )
	Call WordCloud_SetIgnoreCount(hChild, 1)
	Call WordCloud_SetColor(hChild, RGB(42, 73, 88), GetSysColor(%COLOR_3DFACE), RGB(94, 53, 56))

	Call WordCloud_LoadFile(hChild, "example.txt")
	Call WordCloud_AddFile(hChild, "example2.txt")
	Call WordCloud_IgnoreFile(hChild, "ignore.txt")

	Call WordCloud_Sort(hChild, %wcSortType.Name)

	Call WordCloud_PaintControl(hChild, %wcPaintControl.Resume)

	ShowWindow( hWnd, %SW_Show )
	UpdateWindow( hWnd )

	Call Run()
End Function

Function WndProc( ByVal hWnd As Dword, ByVal wMsg As Dword, ByVal wParam As Long, ByVal lParam As Long) As Long
	Local v As AsciiZ Ptr
	Local msg As String
	Local hChild As Dword
	Local idx As Long
	Function = 0
	Select Case wMsg
		Case %WM_Command:
			If Lo(Word, wparam)=%CTL_SORT And Hi(Word,wparam) = %LBN_SelChange Then
				idx = SendMessage( lParam, %CB_GETCURSEL, 0, 0 )
				hChild = GetDlgItem( hWnd, %CTL_WC )
				Call PostMessage( hChild, %WCM_Sort, idx+1, 0 ): Exit Function
			End If
		Case %WM_CTLCOLORSTATIC:
			SetTextColor(wParam, RGB(0,0,0))
			Function = GetSysColorBrush(%COLOR_WINDOW)
			Exit Function
		Case %WM_Size
			Call Window_OnSize( hWnd )
		Case %WM_Destroy
			PostQuitMessage( 0 )
			Exit Function
		Case %WM_Notify
			Local hdr As NmHdr Ptr
			hdr = lParam
			If @hdr.idFrom=%CTL_WC Then
				' Word Cloud
				Local wc As WCCLICKED Ptr
				wc = lParam
				msg = @wc.@pszKey & " = " & Str$(@wc.cnt)
				v = StrPtr(msg)
				hChild = GetDlgItem( hWnd, %CTL_STATUS )
				SetWindowText( hChild, @v )
				Exit Function
			ElseIf @hdr.idFrom=%CTL_LINK Then
				' Link label
				Local ll As LLCLICKED Ptr
				ll = lParam
				msg = "Link clicked: " + @ll.@pszKey
				v = StrPtr(msg)
				hChild = GetDlgItem( hWnd, %CTL_STATUS )
				SetWindowText( hChild, @v )
				Exit Function
			End If
	End Select
	Function = DefWindowProc( hWnd, wMsg, wParam, lParam )
End Function

Sub Window_OnSize( ByVal hWnd As Dword )
	Local rc As RECT
	Local hChild As Dword

	GetClientRect( hWnd, rc )

	hChild = GetDlgItem( hWnd, %CTL_WC )
	SetWindowPos( hChild,  0, 30,             0, rc.Right,  rc.Bottom-30, %SWP_NOMOVE Or %SWP_NOZORDER )

	hChild = GetDlgItem( hWnd, %CTL_SORT )
	SetWindowPos( hChild, 0, rc.Right-150-5, 4, 150,       115, %SWP_NOZORDER )
End Sub

Sub Initialize()
	Static init As Long
	Dim wc As WNDCLASS
	Dim className As AsciiZ*40

	If init Then Exit Sub: ' Already initialized

	' Register class for Overlapped window
	className = $WIN_CLASS
	wc.style = 0
	wc.lpfnWndProc = CodePtr( WndProc )
	wc.cbClsExtra = 0
	wc.cbWndExtra = 0
	wc.hInstance = GetModuleHandle(ByVal 0)
	wc.hIcon = LoadIcon(%NULL, ByVal %IDI_APPLICATION)
	wc.hCursor = LoadCursor(%NULL, ByVal %IDC_ARROW)
	wc.hbrBackground = GetSysColorBrush( %COLOR_WINDOW )
	wc.lpszMenuName =  0
	wc.lpszClassName = VarPtr(className)

	If RegisterClass( wc )=0 Then
		MsgBox "RegisterClass for lcDemoWin failed: " + SystemError()
		End
	End If
	init = -1
End Sub

Function SystemError() Common As String
		Local errorCode As Dword
		Local buffer As AsciiZ * 512
		errorCode = GetLastError()
		FormatMessage( %FORMAT_MESSAGE_FROM_SYSTEM, ByVal %NULL, errorCode, %NULL, buffer, SizeOf(buffer), ByVal %NULL )
		Function = buffer
End Function

Function Run() As Long
	Dim msg As tagMSG
	Dim hActive As Dword
	While GetMessage( msg, %NULL, 0, 0 )
		hActive = GetActiveWindow()
		If hActive = 0 Or IsDialogMessage( hActive, msg ) = 0 Then
			TranslateMessage( msg )
			DispatchMessage( msg )
		End If
	Wend
End Function
